WHODAD_mixture=function(y1,y0,yb){
  # yb: vector of k0 values for all top candidate-offspring dyads 
  # y0: vector of k0 values for all known mother-offspring dyads; Note that if there are no mother-offspring dyads then this should be an empty vector: e.g., y0=c()
  # y1: vector of k0 values for all other dyads
  
  y0=log(y0/(1-y0))
  yb=log(yb/(1-yb))
  
  library(mixtools)
  dmnormal<-function(u, w=c(), m=c(), sigma2) {
    w*dnorm(u, m, sqrt(sigma2) )
    return(d)
  }
  
  # fit the null with five components; if it outputs "WARNING! NOT CONVERGENT!", then you need to re-run this function. This function will also try different random starting points and when it does, it will also output "One of the variances is going to zero;  trying new starting values." over and over again. You can ignore this message.
  nc=5
  fit0=normalmixEM(y0, lambda=rep(1/nc, nc), mu=quantile(y0, seq(1/nc, 1, by=1/nc)), sigma=rep(1, nc), maxit=100000, maxrestarts=10000 )
  
  # now fit the model; a vector pz contains the posterior probability of being in the alternative distribution.
  if (length(y1>0)) {
    y1=log(y1/(1-y1))
    nt=length(yb); n1=length(y1);
    d2=c()
    for (i in 1:nt) {
      d=c()
      for (j in 1:nc) {
        d=c(d, dnorm(yb[i], fit0$mu[j], fit0$sigma[j]))
      }
      d2=c(d2, max(d))
    }
    
    p=0.5; a=1; b=1; mu=mean(y1); sigma2=var(y1)
    for (t in 1:50) {
      d1=dnorm(yb, mu, sqrt(sigma2))
      pz=p*d1/(p*d1+(1-p)*d2)
      p=(sum(pz)+a)/(nt+a+b)
      mu=(sum(pz*yb)+sum(y1))/(sum(pz)+n1)
      sigma2=(sum(pz*(yb-mu)^2)+sum((y1-mu)^2))/(sum(pz)+n1)
      print(c(p, mu, sigma2))
      
    }} 
  if (length(y1)==0) {
    nt=length(yb); n1=0;
    d2=c()
    for (i in 1:nt) {
      d=c()
      for (j in 1:nc) {
        d=c(d, dnorm(yb[i], fit0$mu[j], fit0$sigma[j]))
      }
      d2=c(d2, max(d))
    }
    
    p=0.5; a=1; b=1; mu=0; sigma2=1
    for (t in 1:50) {
      d1=dnorm(yb, mu, sqrt(sigma2))
      pz=p*d1/(p*d1+(1-p)*d2)
      p=(sum(pz)+a)/(nt+a+b)
      mu=(sum(pz*yb)+sum(y1))/(sum(pz)+n1)
      sigma2=(sum(pz*(yb-mu)^2)+sum((y1-mu)^2))/(sum(pz)+n1)
      print(c(p, mu, sigma2))
      
    }}  
  return(pz)
}